/*
 *
 */
import java.io.*;
import java.util.*;
import java.net.*;
import java.text.*;

public class ErrorCode {
    /* Error code number */
    private int errorCode;
    /* Error code html page */
    private String errorHtml;
    /* Error code description text */
    private String errorText;

    public ErrorCode(int e,HttpRequest httpRequest) {
        errorCode=e;
        errorText=getErrorText(errorCode);
        String str="";
        if(errorCode==302) {
            str="<html><head><title>redirection!</title></head><body><h1>redirection!</h1><p>";
            str=str+"You get this page because your browser doesn't support automatic redirection.<br>";
            str=str+"The page you're trying to find can be found <a href=\""+httpRequest.httpURL+"/\">here</a>.</body></html>";
        } else if(errorCode!=304&errorCode!=302&errorCode!=412) {
            str="<html><head><title>ERROR: The requested URL could not be retrieved</TITLE>\r\n</HEAD><BODY>\r\n";
            str=str+"<H1>ERROR "+e+"</H1>\r\n<H2>The requested URL could not be retrieved</H2>\r\n<HR><P>";
            if(httpRequest.httpURL!=null&errorCode!=414)
                str=str+"While trying to retrieve the URL: <A HREF='"+httpRequest.httpURL+"'>"+httpRequest.httpURL+"</A><P>\r\n";
            str=str+"The following error was encountered:\r\n<UL>\r\n<LI>\r\n";
            str=str+"<STRONG>"+errorText+"</STRONG>\r\n</UL><P>\r\n</BODY></html>";
        }
        if(httpRequest.httpVersion>=1.0) {
            errorHtml="HTTP/1.0 "+e+" "+errorText+"\r\n";
            SimpleDateFormat formatter=new SimpleDateFormat("EEE, dd MMM yyyy HH:mm:ss 'GMT'",new Locale("en","US"));
            errorHtml=errorHtml+"Date: "+formatter.format(new Date())+"\r\n";
            errorHtml=errorHtml+"Server: JavaTest-HTTPD v1.0\r\n";
            if(errorCode==302)
                errorHtml=errorHtml+"Location: "+httpRequest.httpURL+"/\r\n";
            errorHtml=errorHtml+"Content-Length: "+str.length()+"\r\n";
            if(errorCode!=304&errorCode!=412) {
                errorHtml=errorHtml+"Content-Type: text/html\r\n";
            }
            errorHtml=errorHtml+"\r\n"+str;
        } else {
            errorHtml=str;
        }
    }

    public String toString() {
        return errorHtml;
    }

    private String getErrorText(int e) {
        switch(e) {
        case 100:
            return "Continue";
        case 302:
            return "Found";
        case 304:
            return "Not Modified";
        case 400:
            return "Bad Request";
        case 404:
            return "Not found";
        case 412:
            return "Precondition Failed";
        case 414:
            return "Request-URI Too Long";
        case 500:
            return "Internal Server Error";
        case 501:
            return "Not implemented";
        default:
            return "Unknown error";
        }
    }
}
