/*
 * JavaTest-HTTPD v1.0
 */
import java.io.*;
import java.net.*;

public class jthttpd {
    private static String httpDir=".\\html";
    private static String cgiDir=".\\cgi-bin";
    private static int bindTcpPort=80;
    private static int bindMaxClients=10;
    private static InetAddress bindIp=null;
    private static ServerSocket server;
    private static Socket sok;

    public static void main(java.lang.String[] args) {
        System.out.println("-= JavaTest-HTTPD v1.0 =-");
        System.out.print("\n-= Initializing...");
        try {
            if(args.length==1) {
                bindTcpPort=Integer.parseInt(args[0]);
            } else if(args.length==2) {
                bindTcpPort=Integer.parseInt(args[0]);
                bindMaxClients=Integer.parseInt(args[1]);
            } else if(args.length==3) {
                bindTcpPort=Integer.parseInt(args[0]);
                bindMaxClients=Integer.parseInt(args[1]);
                bindIp=InetAddress.getByName(args[2]);
            } else if(args.length!=0) {
                System.out.println("\n-=ERROR: Invalid number of arguments.");
                System.exit(1);
            }
            server=new ServerSocket(bindTcpPort,bindMaxClients,bindIp);
            if(args.length!=3)
                bindIp=server.getInetAddress();
        } catch(IOException e) {
            System.out.println("\n-= ERROR: Can't bind to port "+bindTcpPort);
            System.exit(1);
        }
        System.out.println(" OK");
        System.out.println("-= Listening on "+bindIp+" at port "+bindTcpPort);
        System.out.print("-= Serving clients:");
        while(true) {
            try { sok=server.accept(); }
            catch(IOException e) {
                System.out.println("-= ERROR: Can't bind to socket.");
                System.exit(1);
            }
            System.out.print(".");
            ServThread thread=new ServThread(sok);
            thread.start();
        }
    }

    private void handleException(java.lang.Throwable exception) {
        System.out.println("--------- UNCAUGHT EXCEPTION ---------");
        exception.printStackTrace(System.out);
    }

}
